DEFINT A-Z

 TYPE Location
   X AS INTEGER
   Y AS INTEGER
 END TYPE

 TYPE ScrollStats
  InBitmap AS Location
  XToDraw AS INTEGER
  YToDraw AS INTEGER
  ScreenX  AS INTEGER
  ScreenY AS INTEGER
 END TYPE
  
 TYPE Composite
   InMap AS Location
   InBitmap AS Location
 END TYPE


DECLARE FUNCTION LONGTIMER&
DECLARE SUB ShowScrollStats (Stats AS ANY, X%, Y%)

DECLARE FUNCTION DRAWBITMAP% (SEG Bitmap%, SEG BaseStats AS ScrollStats, SEG CurrStats AS ScrollStats)
DECLARE FUNCTION DRAWSOLID% (BYVAL Solid%, SEG Bitmap%, SEG BaseStats AS ScrollStats, SEG CurrStats AS ScrollStats)

DECLARE FUNCTION ARRAYPOINT13% (SEG Array%, BYVAL X%, BYVAL Y%)

DECLARE SUB MAPSUB (SEG Bitmap%, SEG InMap AS INTEGER, SEG InBitmap AS INTEGER)
DECLARE SUB MAPADD (SEG Bitmap%, SEG InMap AS INTEGER, SEG InBitmap AS INTEGER)

DECLARE SUB MapRightCS (Map%(), Bitmap%(), BaseStats AS ANY, BaseInMap AS ANY, Final AS ANY, FinalLimitHigh AS ANY)
DECLARE SUB MapLeftCS (Map%(), Bitmap%(), BaseStats AS ANY, BaseInMap AS ANY, Final AS ANY, FinalLimitLow AS ANY)
DECLARE SUB MapUpCS (Map%(), Bitmap%(), BaseStats AS ANY, BaseInMap AS ANY, Final AS ANY, FinalLimitLow AS ANY)
DECLARE SUB MapDownCS (Map%(), Bitmap%(), BaseStats AS ANY, BaseInMap AS ANY, Final AS ANY, FinalLimitHigh AS ANY)

DECLARE SUB DrawMap (Map%(), Bitmap%(), BaseStats AS ANY, BaseInMap AS ANY, Final AS ANY)
DECLARE SUB Mosaic (Map%(), Bitmap%(), BaseStats AS ANY, BaseInMap AS ANY, Size%)

DECLARE FUNCTION FileOPEN% (FileName$, Mode$)

OPEN "LEVEL1.DAT" FOR INPUT AS #1
INPUT #1, Temp%
INPUT #1, Temp%
INPUT #1, LevData.TotalTiles.X, LevData.TotalTiles.Y, LX, LY'dont have a clue what these last two do

DIM LV(0 TO LevData.TotalTiles.X - 1, 0 TO LevData.TotalTiles.Y - 1)
FOR t = 0 TO LevData.TotalTiles.Y - 1
INPUT #1, a$
FOR e = 0 TO LevData.TotalTiles.X - 1
LV(e, t) = 0
B$ = MID$(a$, e + 1, 1)
IF B$ = "B" THEN LV(e, t) = 1
IF B$ = "G" THEN LV(e, t) = 2
IF B$ = "L" THEN LV(e, t) = 5
IF B$ = "T" THEN LV(e, t) = 3
NEXT: NEXT
   DIM Bitmap%(0 TO 129, 0 TO 5)
    CONST BitmapX% = 0
    CONST BitmapY% = 1
    CONST East = BitmapX% * 2
    CONST West = BitmapX% * 2 + 1
    CONST North = BitmapY% * 2
    CONST South = BitmapY% * 2 + 1

  fc1% = FileOPEN("IMG.LST", "I")
    FOR I = 0 TO 5
      LINE INPUT #fc1, a$
      fc2% = FileOPEN(a$, "B")
        FOR J = 0 TO 129
          GET fc2%, , Bitmap(J, I)
        NEXT J
      CLOSE fc2%
    NEXT
  CLOSE fc1%
  DIM Final AS Composite, FinalLimitLow AS Composite, FinalLimitHigh AS Composite
  DIM BaseStats AS ScrollStats, BaseInMap AS Location
SCREEN 13
  FinalLimitHigh.InMap.X = UBOUND(LV, 1)
  FinalLimitHigh.InMap.Y = UBOUND(LV, 2)
  FinalLimitHigh.InBitmap.X = Bitmap%(0, LV(UBOUND(LV, 1), UBOUND(LV, 2))) - 1
  FinalLimitHigh.InBitmap.Y = Bitmap%(1, LV(UBOUND(LV, 1), UBOUND(LV, 2))) - 1
  BaseStats.XToDraw = 320
  BaseStats.YToDraw = 200
  DrawMap LV(), Bitmap(), BaseStats, BaseInMap, Final
  DO
    SELECT CASE INKEY$
    CASE "8", CHR$(0) + "H"
    Dir% = 1
    CASE "2", CHR$(0) + "P"
    Dir% = 2
    CASE "4", CHR$(0) + "K"
    Dir% = 3
    CASE "6", CHR$(0) + "M"
    Dir% = 4
    CASE "7"
    Dir% = 5
    CASE "9"
    Dir% = 6
    CASE "1"
    Dir% = 7
    CASE "3"
    Dir% = 8
    CASE " "
    Dir% = 0
    CASE "M", "m"
      'Mosaic isn't working right now
      'DoMosaic% = -1
      'MosaicSize% = 1
      'RedrawType% = 4
    CASE CHR$(27)
      END
    END SELECT
    SELECT CASE Dir%
    CASE 1
    MapUpCS LV(), Bitmap%(), BaseStats, BaseInMap, Final, FinalLimitLow
    Redraw% = -1
    CASE 2
     MapDownCS LV(), Bitmap%(), BaseStats, BaseInMap, Final, FinalLimitHigh
     Redraw% = -1
    CASE 3
     MapLeftCS LV(), Bitmap%(), BaseStats, BaseInMap, Final, FinalLimitLow
     Redraw% = -1
    CASE 4
      MapRightCS LV(), Bitmap%(), BaseStats, BaseInMap, Final, FinalLimitHigh
      Redraw% = -1
    CASE 5
      MapUpCS LV(), Bitmap%(), BaseStats, BaseInMap, Final, FinalLimitLow
      MapLeftCS LV(), Bitmap%(), BaseStats, BaseInMap, Final, FinalLimitLow
      Redraw% = -1
    CASE 6
      MapUpCS LV(), Bitmap%(), BaseStats, BaseInMap, Final, FinalLimitLow
      MapRightCS LV(), Bitmap%(), BaseStats, BaseInMap, Final, FinalLimitHigh
      Redraw% = -1
    CASE 7
     MapDownCS LV(), Bitmap%(), BaseStats, BaseInMap, Final, FinalLimitHigh
     MapLeftCS LV(), Bitmap%(), BaseStats, BaseInMap, Final, FinalLimitLow
     Redraw% = -1
    CASE 8
     MapDownCS LV(), Bitmap%(), BaseStats, BaseInMap, Final, FinalLimitHigh
     MapRightCS LV(), Bitmap%(), BaseStats, BaseInMap, Final, FinalLimitHigh
     Redraw% = -1
    END SELECT
    IF DoMosaic% THEN
      Redraw = -1
      IF GoingDown% THEN
        MosaicSize% = MosaicSize% - 1
        IF MosaicSize = 1 THEN
          DoMosaic% = 0
          GoingDown% = 0
          RedrawType% = RegularRedraw%
        END IF
      ELSE
        MosaicSize% = MosaicSize% + 1
        IF MosaicSize = 20 THEN GoingDown% = -1

      END IF
    END IF

    IF Redraw% THEN
      SELECT CASE RedrawType%
      CASE 0
       DrawMap LV(), Bitmap(), BaseStats, BaseInMap, Final
      CASE 1 'Animated
      CASE 2 'Static SKip Frame
      CASE 3 'Animated Skip Frame
      CASE 4
       Mosaic LV(), Bitmap(), BaseStats, BaseInMap, MosaicSize%
      END SELECT
      Redraw = 0
    END IF
  LOOP

SUB DrawMap (Map(), Bitmap%(), BaseStats AS ScrollStats, BaseInMap AS Location, Final AS Composite)
    DIM CurrStats AS ScrollStats, CurrInMap AS Location
    CurrStats = BaseStats
    CurrInMap = BaseInMap
    DO
      IF DRAWBITMAP(Bitmap%(0, Map(CurrInMap.X, CurrInMap.Y)), BaseStats, CurrStats) THEN
        Final.InMap = CurrInMap
        Final.InBitmap = CurrStats.InBitmap
        LOCATE 1, 1
        'PRINT CurrInMap.X
        'PRINT CurrStats.InBitmap.X
        'TIM# = TIMER + 1: DO: LOOP UNTIL TIM# < TIMER
        EXIT DO
      END IF
      'LOCATE (CurrInMap.Y - BaseInMap.Y) * 2 + 1, (CurrInMap.X - BaseInMap.X) * 2 + 1
      'PRINT LTRIM$(STR$(CurrInMap.X));

      IF CurrStats.XToDraw = BaseStats.XToDraw THEN
       CurrInMap.X = BaseInMap.X
       CurrInMap.Y = CurrInMap.Y + 1
      ELSE
        CurrInMap.X = CurrInMap.X + 1
      END IF
    LOOP
END SUB

FUNCTION FileOPEN% (FileName$, Mode$)
    FileOPEN% = FREEFILE
    OPEN Mode$, FREEFILE, FileName$
END FUNCTION

SUB MapDownCS (Map(), Bitmap%(), BaseStats AS ScrollStats, BaseInMap AS Location, Final AS Composite, FinalLimitHigh AS Composite)
    'CameraStops
    IF Final.InMap.Y = FinalLimitHigh.InMap.Y THEN
       IF Final.InBitmap.Y = FinalLimitHigh.InBitmap.Y THEN
         EXIT SUB
       END IF
    END IF
      'CALL ShowScrollStats(BaseStats, 10, 19)
     
    MAPADD Bitmap%(1, Map(BaseInMap.X, BaseInMap.Y)), BaseInMap.Y, BaseStats.InBitmap.Y
    'Diagnostics
      'CALL ShowScrollStats(BaseStats, 22, 19)
      'DO: LOOP UNTIL INKEY$ <> ""
    'Old Code...
    'BaseStats.InBitmap.Y = BaseStats.InBitmap.Y + 1
    'IF BaseStats.InBitmap.Y = Bitmap%(1, Map(BaseInMap.Y, BaseInMap.Y)) THEN
    '  BaseStats.InBitmap.Y = 0
    '   BaseInMap.Y = BaseInMap.Y + 1
    'END IF
END SUB

SUB MapLeftCS (Map(), Bitmap%(), BaseStats AS ScrollStats, BaseInMap AS Location, Final AS Composite, FinalLimitLow AS Composite)
    'CameraStops
    IF BaseInMap.X = FinalLimitLow.InBitmap.X THEN
       IF BaseStats.InBitmap.X = FinalLimitLow.InBitmap.X THEN
         EXIT SUB
       END IF
    END IF
    
    MAPSUB Bitmap%(0, Map(BaseInMap.X, BaseInMap.Y)), BaseInMap.X, BaseStats.InBitmap.X
    'IF BaseStats.InBitmap.X = 0 THEN
    '   BaseInMap.X = BaseInMap.X - 1
    '   BaseStats.InBitmap.X = Bitmap%(0, Map(BaseInMap.X, BaseInMap.Y)) - 1
    'ELSE
    '   BaseStats.InBitmap.X = BaseStats.InBitmap.X - 1
    'END IF
END SUB

SUB MapRightCS (Map(), Bitmap%(), BaseStats AS ScrollStats, BaseInMap AS Location, Final AS Composite, FinalLimitHigh AS Composite)
    'CameraStops
    IF Final.InMap.X = FinalLimitHigh.InMap.X THEN
       IF Final.InBitmap.X = FinalLimitHigh.InBitmap.X THEN
         EXIT SUB
       END IF
    END IF
    MAPADD Bitmap%(0, Map(BaseInMap.X, BaseInMap.Y)), BaseInMap.X, BaseStats.InBitmap.X
    'BaseStats.InBitmap.X = BaseStats.InBitmap.X + 1
    'IF BaseStats.InBitmap.X = Bitmap%(0, Map(BaseInMap.X, BaseInMap.Y)) THEN
    '   BaseStats.InBitmap.X = 0
    '   BaseInMap.X = BaseInMap.X + 1
    'END IF
END SUB

SUB MapUpCS (Map(), Bitmap%(), BaseStats AS ScrollStats, BaseInMap AS Location, Final AS Composite, FinalLimitLow AS Composite)
    'CameraStops
    IF BaseInMap.Y = FinalLimitLow.InBitmap.Y THEN
       IF BaseStats.InBitmap.Y = FinalLimitLow.InBitmap.Y THEN
         EXIT SUB
       END IF
    END IF
   
    MAPSUB Bitmap%(1, Map(BaseInMap.X, BaseInMap.Y)), BaseInMap.Y, BaseStats.InBitmap.Y
    'IF BaseStats.InBitmap.Y = 0 THEN
    '   BaseInMap.Y = BaseInMap.Y - 1
    '   BaseStats.InBitmap.Y = Bitmap%(1, Map(BaseInMap.Y, BaseInMap.Y)) - 1
    'ELSE
    '   BaseStats.InBitmap.Y = BaseStats.InBitmap.Y - 1
    'END IF
END SUB

SUB Mosaic (Map(), Bitmap%(), BaseStats AS ScrollStats, BaseInMap AS Location, Size%)
   
    DIM CurrInMap AS Location, InternalStats AS ScrollStats
   
    InternalStats = BaseStats
    CurrXToDraw% = BaseStats.XToDraw
    CurrYToDraw% = BaseStats.YToDraw
    CurrInMap = BaseInMap
    CurrSizeX% = Size%
    CurrSizeY% = Size%
    InternalStats.YToDraw = CurrSizeY%
    ColorToDraw% = ARRAYPOINT13(Bitmap%(0, Map(CurrInMap.X, CurrInMap.Y)), InternalStats.InBitmap.X, InternalStats.InBitmap.Y)
    DO
      IF CurrXToDraw < Size% THEN CurrSizeX% = CurrXToDraw
      InternalStats.XToDraw = CurrSizeX%
      'DO
        'If done with this color then get new color
        PrevY% = InternalStats.InBitmap.Y
        IF DRAWSOLID(ColorToDraw%, Bitmap%(0, Map(CurrInMap.X, CurrInMap.Y)), BaseStats, InternalStats) THEN
          ColorToDraw% = ARRAYPOINT13(Bitmap%(0, Map(CurrInMap.X, CurrInMap.Y)), InternalStats.InBitmap.X, InternalStats.InBitmap.Y)
          'EXIT DO
        END IF
        'CurrInMap.X = CurrInMap.X + 1
      'LOOP
      CurrXToDraw = CurrXToDraw - CurrSizeX%
      IF CurrXToDraw = 0 THEN
        CurrYToDraw = CurrYToDraw - CurrSizeY%
        IF CurrYToDraw = 0 THEN
          EXIT DO
        ELSEIF CurrYToDraw < Size% THEN
          InternalStats.YToDraw = CurrYToDraw
          CurrSizeY% = CurrYToDraw
        END IF
        CurrXToDraw = BaseStats.XToDraw
        MAPADD Bitmap%(1, Map(CurrInMap.X, CurrInMap.Y)), CurrInMap.Y, InternalStats.InBitmap.Y
        CurrSizeX = Size%
        CurrInMap.X = BaseInMap.X
        CurrInMap.Y = CurrInMap.Y + 1
        InternalStats.InBitmap.X = BaseStats.InBitmap.X
        InternalStats.ScreenX = BaseStats.ScreenX
      ELSE
        MAPADD Bitmap%(0, Map(CurrInMap.X, CurrInMap.Y)), CurrInMap.X, InternalStats.InBitmap.X
        InternalStats.ScreenX = InternalStats.ScreenX + 1
        InternalStats.InBitmap.Y = InternalStats.InBitmap.Y
      END IF
   LOOP
'OldRoutine
'DIM FakeFinalLimitHigh AS Composite
'TSize% = Size - 1
'FOR Y = 1 TO BaseStats.YToDraw 'STEP W
'   MAPADD Bitmap%(0, Map(CurrInMap.X, CurrInMap.Y)), CurrInMap.Y, CurrStats.InBitmap.Y
'   IF Y MOD Size% = 0 THEN
'     FOR X = 1 TO BaseStats.XToDraw 'STEP W
'       LINE (X, Y)-(X + TSize%, Y + TSize%), ARRAYPOINT13(Bitmap%(0, Map(CurrInMap.X, CurrInMap.Y)), CurrStats.InBitmap.X, CurrStats.InBitmap.Y), BF
'       MAPADD Bitmap%(0, Map(CurrInMap.X, CurrInMap.Y)), CurrInMap.X, CurrStats.InBitmap.X
'     NEXT
'     CurrInMap.X = BaseInMap.X
'     CurrStats.InBitmap.X = BaseStats.InBitmap.X
'END IF
  'MapDownCS(Map(), Bitmap%(), BaseStats AS ScrollStats, BaseInMap AS Location, Final, FakeFinalsLimitHigh)
'NEXT Y
'END
END SUB

SUB ShowScrollStats (Stats AS ScrollStats, X, Y)
    LOCATE Y, X
    PRINT "BitmapX:"; Stats.InBitmap.X;
    LOCATE Y + 1, X
    PRINT "BitmapY:"; Stats.InBitmap.Y;
    LOCATE Y + 2, X
    PRINT "XToDraw:"; Stats.XToDraw;
    LOCATE Y + 3, X
    PRINT "YToDraw:"; Stats.YToDraw;
    LOCATE Y + 4, X
    PRINT "ScreenX:"; Stats.ScreenX;
    LOCATE Y + 5, X
    PRINT "ScreenY:"; Stats.ScreenY;
  
END SUB

