DEFINT A-Z
'$DYNAMIC
TYPE ChunkHeader
  ChunkType AS STRING * 4
  ChunkSize AS LONG
END TYPE

DECLARE FUNCTION GetKey% ()
DECLARE FUNCTION FileOPEN% (FileName$, Mode$)
DECLARE FUNCTION ReverseLong& (longInt&)
DECLARE FUNCTION NumberOfChunks% (fc%, ChunkType$)

DIM SHARED NamedKeys$(0 TO 25)
DIM SHARED NamedKeyMappings(0 TO 25) AS STRING * 2

REM $STATIC
SUB CheckKeys

END SUB

SUB ExportKeys (FileName$, KeyMappings() AS STRING, KeyedEvents%())
    DIM Header AS ChunkHeader
    fc% = FileOPEN(FileName$, "B")
    Header.ChunkType = "KEYM"
    CurrEvent% = 1
ExportKeysTop:
    IF CurrEvent% <> UBOUND(KeyedEvents%) THEN
      Header.ChunkSize = 2 * (KeyedEvents%(CurrEvent% + 1) - KeyedEvents%(CurrEvent%))
    ELSE
      Header.ChunkSize = 2 * (UBOUND(KeyMappings) - KeyedEvents%(CurrEvent%) + 1)
    END IF
     Header.ChunkSize = ReverseLong&(Header.ChunkSize)
     PUT #fc%, , Header
     Header.ChunkSize = ReverseLong&(Header.ChunkSize)
     FOR i% = 1 TO Header.ChunkSize / 2
        PUT #fc%, , KeyMappings(PlaceHolder)
        PlaceHolder = PlaceHolder + 1
     NEXT i
     IF CurrEvent% <> UBOUND(KeyedEvents%) THEN
      CurrEvent% = CurrEvent + 1
      GOTO ExportKeysTop
     END IF
    CLOSE fc%
END SUB

FUNCTION GetKey%
    Key$ = INKEY$
    SELECT CASE LEN(Key$)
    CASE 0
      GetKey% = CVI(CHR$(0) + CHR$(0))
    CASE 1
      GetKey% = CVI(Key$ + CHR$(0))
    CASE 2
      GetKey% = CVI(Key$)
    END SELECT
END FUNCTION

SUB ImportKeys (FileName$, KeyMappings() AS STRING, KeyedEvents%())
    DIM Header AS ChunkHeader
    fc% = FileOPEN(Filenmae$, "B")
   
    CALL NumberOfChunks(fc%, "KEYM")
    REDIM KeyedEvents%(1 TO NumberOfChunks(fc%, "KEYM"))

END SUB

