    DEBUGREPORT MACRO  ItemToSpy
	MOV AX, ItemToSpy
    POP DS
    POP BP
    RETF 12
	#EM


    ;Bitmap, BaseStats, CurrStats 
    ;[BP+14] [BP+10]    [BP+6]
PUBLIC DRAWBITMAP
DRAWBITMAP PROC FAR
    PUSH BP
    MOV BP, SP
    push DS

;Intended Result: Blocks to transfer for this Block in ??
;Start of X Verification
    lds si, [bp + 14] ;Bitmap
    LES DI, [BP + 6]    ;CurrStats
    LODSW                                  ;Move Bitmap X into AX
    PUSH AX   ;Save it We're going to need it in calculating the rollover
    MOV BX, ES:[DI];CurrStats.InBitmapX
    SUB AX, BX
    ADD DI, 4
    MOV BX, ES:[DI];CurrStats.XToDraw
    CMP BX, AX
    JLE FineX  ;If BX is less than or equal to AX then Goto fine
    MOV BX, AX ;Else Load BX with AX(the maximum to transfer
FineX:
    POP AX
    SUB ES:[DI], BX ;CurrStats.XToDraw
    SUB AX, BX
    PUSH BX ;BytesToTransferX
    ;Still to come: calculating the screen rollover and doing the transfer
    PUSH AX
    ;Still to come: doing the bitmap rollover
    DEC DI
    DEC DI
    LODSW
    MOV CX, ES:[DI] ;CurrStats.BitmapY
    SUB AX, CX
    ADD DI, 4
    MOV CX, ES:[DI] ;CurrStats.YToDraw
    CMP CX, AX
    JLE FineY  ;If CX is less than or equal to
    MOV CX, AX
FineY:
    ;SUB ES:[DI], CX

    ;Intended result: DS:SI = Section of Bitmap to point to
    LES DI, [BP + 6]    ;CurrStats
    lds si, [bp + 14] ;Bitmap
    LODSW
    mov BX, ES:[DI]  ;CurrStats.BitmapX
    INC DI
    INC DI
    MUL WORD PTR ES:[DI];CurrStats.BitmapY
    ADD AX, BX
    ADD SI, AX
    INC SI  ;Step over Y
    INC SI
;Result:  DS:SI = Section of Bitmap to point to

     ADD DI, 8
     MOV  AX, ES:[DI]     ; Move Screen  Y into AX
     MOV  BX, 320 ;Multiply by 320 pixels in the x direction
     MUL  BX

      DEC DI
      DEC DI
     
      ADD  AX, ES:[DI]
      ;We're Completely done with the old uses of ES:[DI]
      ;so we can move the new definitions in
      MOV  DI, AX
      MOV  AX, 0A000h
      MOV  ES, AX
	  pop DX
	  POP AX
      sub BX, AX
      push cx ;YToDraw
StartY3:
    PUSH    CX;YToDraw
    MOV     CX, AX
    REP MOVSB
    ADD     DI, BX
    ADD     SI, DX
    POP     CX;YToDraw
    LOOP StartY3
    POP CX ;YToDraw
    
    LES DI, [BP + 6]  ;CurrStats
    ADD DI, 4
    CMP WORD PTR ES:[DI], 0 ;CurrStats.XToDraw
    JZ XZero
    ADD DI, 4
    ADD ES:[DI], AX ;CurrStats.ScreenX
    MOV AX, 0
    LES DI, [BP + 6]  ;CurrStats
    STOSW
    POP DS
    POP BP
    RETF 12
    
XZero:
    lds si, [BP + 10] ;BaseStats
    ADD SI, 4
    MOVSW
    SUB ES:[DI], CX ;CurrStats.YToDraw
    CMP WORD PTR ES:[DI], 0
    JZ YZero
    INC DI
    INC DI
    lds si, [BP + 10] ;BaseStats
    ADD SI, 8
    MOVSW
    ADD ES:[DI], CX
    LES DI, [BP + 6]  ;CurrStats
    lds si, [BP + 10] ;BaseStats
    MOVSW
    MOV AX, 0
    STOSW

    POP DS
    POP BP
    RETF 12


YZero:
    lds si, [BP + 6] ;CurrStats
    ADD [SI], AX
    DEC WORD PTR [SI]
    INC SI
    INC SI
    ADD [SI], CX
    DEC WORD PTR [SI]
    ADD SI, 6
    ADD [SI], AX
    INC SI
    INC SI
    ADD [SI], CX
    MOV AX, 0FFFFh

    POP DS
    POP BP
    RETF 12
ENDP

PUBLIC CALCBITMAP
CALCBITMAP PROC FAR
    PUSH BP
    MOV BP, SP
    push DS

;Intended Result: Blocks to transfer for this Block in ??
;Start of X Verification
    lds si, [bp + 14] ;Bitmap
    LES DI, [BP + 6]    ;CurrStats
    LODSW
    PUSH AX
    MOV BX, ES:[DI];CurrStats.InBitmapX
    SUB AX, BX
    ADD DI, 4
    MOV BX, ES:[DI];CurrStats.XToDraw
    CMP BX, AX
    JLE FineX2  ;If BX is less than or equal to AX then Goto fine
    MOV BX, AX ;Else Load BX with AX(the maximum to transfer
FineX2:
    POP AX
    SUB ES:[DI], BX ;CurrStats.XToDraw
    SUB AX, BX
    PUSH BX ;BytesToTransferX
    PUSH AX
    DEC DI
    DEC DI
    LODSW
    MOV CX, ES:[DI] ;CurrStats.BitmapY
    SUB AX, CX
    ADD DI, 4
    MOV CX, ES:[DI] ;CurrStats.YToDraw
    CMP CX, AX
    JLE FineY2  ;If CX is less than or equal to
    MOV CX, AX
FineY2:
    ;SUB ES:[DI], CX

    ;Intended result: DS:SI = Section of Bitmap to point to
    LES DI, [BP + 6]    ;CurrStats
    lds si, [bp + 14] ;Bitmap
    LODSW
    mov BX, ES:[DI]  ;CurrStats.BitmapX
    INC DI
    INC DI
    MUL WORD PTR ES:[DI];CurrStats.BitmapY
    ADD AX, BX
    ADD SI, AX
    INC SI  ;Step over Y
    INC SI
      
     MOV  BX, 320 ;Multiply by 320 pixels in the x direction

     
	  pop DX
	  POP AX
      sub BX, AX
    
      LES DI, [BP + 6]  ;CurrStats
    ADD DI, 4
    CMP WORD PTR ES:[DI], 0 ;CurrStats.XToDraw
    JZ XZero2
    ADD DI, 4
    ADD ES:[DI], AX
    MOV AX, 0
    LES DI, [BP + 6]  ;CurrStats
    STOSW
    POP DS
    POP BP
    RETF 12
    
XZero2:
    lds si, [BP + 10] ;BaseStats
    ADD SI, 4
    MOVSW
    SUB ES:[DI], CX ;CurrStats.YToDraw
    CMP WORD PTR ES:[DI], 0
    JZ YZero2
    INC DI
    INC DI
    lds si, [BP + 10] ;BaseStats
    ADD SI, 8
    MOVSW
    ADD ES:[DI], CX
    LES DI, [BP + 6]  ;CurrStats
    lds si, [BP + 10] ;BaseStats
    MOVSW
    MOV AX, 0
    STOSW

    POP DS
    POP BP
    RETF 12


YZero2:
    lds si, [BP + 6] ;CurrStats
    ADD [SI], AX
    DEC WORD PTR [SI]
    INC SI
    INC SI
    ADD [SI], CX
    DEC WORD PTR [SI]
    ADD SI, 6
    ADD [SI], AX
    INC SI
    INC SI
    ADD [SI], CX

    MOV AX, 0FFFFh

    POP DS
    POP BP
    RETF 12
ENDP

PUBLIC DRAWSOLID
DRAWSOLID PROC FAR
    PUSH BP
    MOV BP, SP
    push DS

;Intended Result: Blocks to transfer for this Block in ??
;Start of X Verification
    lds si, [bp + 14] ;Bitmap
    LES DI, [BP + 6]    ;CurrStats
    LODSW
    MOV BX, ES:[DI];CurrStats.InBitmapX
    SUB AX, BX
    ADD DI, 4
    MOV BX, ES:[DI];CurrStats.XToDraw
    CMP BX, AX
    JLE FineX3  ;If BX is less than or equal to AX then Goto fine
    MOV BX, AX ;Else Load BX with AX(the maximum to transfer
FineX3:
    SUB ES:[DI], BX ;CurrStats.XToDraw
    PUSH BX ;BytesToTransferX
    ;Still to come: calculating the screen rollover and doing the transfer
    DEC DI
    DEC DI 
    LODSW
    MOV CX, ES:[DI] ;CurrStats.BitmapY
    SUB AX, CX
    ADD DI, 4
    MOV CX, ES:[DI] ;CurrStats.YToDraw
    CMP CX, AX
    JLE FineY3  ;If CX is less than or equal to
    MOV CX, AX
FineY3:
    ;SUB ES:[DI], CX
    ;Calc The screen Loc
    LES DI, [BP + 6]    ;CurrStats
    ADD DI, 10
     MOV  AX, ES:[DI]     ; Move Screen  Y into AX
     MOV  BX, 320 ;Multiply by 320 pixels in the x direction
     MUL  BX

      DEC DI
      DEC DI
     
      ADD  AX, ES:[DI]
      MOV  DI, AX
      MOV  AX, 0A000h
      MOV  ES, AX
      
      POP DX
      sub BX, DX
      push cx ;YToDraw
      MOV AX, [BP + 18]
StartY5:
    PUSH    CX;YToDraw
    MOV     CX, DX
    REP STOSB
    ADD     DI, BX

    POP     CX;YToDraw
    LOOP StartY5
    POP CX ;YToDraw
    
    LES DI, [BP + 6]  ;CurrStats
    ADD DI, 4
    CMP WORD PTR ES:[DI], 0 ;CurrStats.XToDraw
    JZ XZero3
    ADD DI, 4
    ADD ES:[DI], DX
    MOV AX, 0
    LES DI, [BP + 6]  ;CurrStats
    STOSW
    POP DS
    POP BP
    RETF 14
    
XZero3:
    lds si, [BP + 10] ;BaseStats
    ADD SI, 4
    MOVSW
    SUB ES:[DI], CX ;CurrStats.YToDraw
    CMP WORD PTR ES:[DI], 0
    JZ YZero3
    INC DI
    INC DI
    lds si, [BP + 10] ;BaseStats
    ADD SI, 8
    MOVSW
    ADD ES:[DI], CX
    LES DI, [BP + 6]  ;CurrStats
    lds si, [BP + 10] ;BaseStats
    MOVSW
    MOV AX, 0
    STOSW

    POP DS
    POP BP
    RETF 14


YZero3:
    lds si, [BP + 6] ;CurrStats
    ADD [SI], DX
    DEC WORD PTR [SI]
    INC SI
    INC SI
    ADD [SI], CX
    DEC WORD PTR [SI]
    ADD SI, 6
    ADD [SI], DX
    INC SI
    INC SI
    ADD [SI], CX
    MOV AX, 0FFFFh

    POP DS
    POP BP
    RETF 14
ENDP


PUBLIC PUT13
PUT13 PROC FAR
    PUSH    BP ; We've got to save the current value of BP because the
               ;program's going to need it later
    MOV     BP, SP ;Move into BP the location of the next place in the stack
    PUSH    DS

    MOV  AX, [BP + 6] ;Load Screen Y placed on the stack 6 bytes earlier
    MOV  BX, 320      ; *320 ...there are 320 x's in one y
    MUL  BX
    ADD  AX, [BP + 8] ;Load Screen X placed on the stack 8 bytes earlier
	MOV     DI, AX

    MOV     AX, 0A000h
    MOV     ES, AX

    LDS     SI, [BP + 0Ah]

    LODSW
    MOV     CX, AX
    SUB     BX, AX ;subtract the bitmap x from screen x

    LODSW
    XCHG    CX, AX
StartY:
    PUSH    CX
    MOV     CX, AX
    REP MOVSB
    ADD     DI, BX
    POP     CX
    LOOP StartY


    POP     DS
    POP     BP
    RET 8
PUT13 ENDP

PUBLIC GET13
GET13 PROC FAR
    PUSH    BP
    MOV     BP, SP
    PUSH    DS

    MOV  AX, [BP + 6]
    MOV  BX, 320
    MUL  BX
    ADD  AX, [BP + 8]
    MOV     DI, AX
    MOV     AX, 0A000h
    MOV     ES, AX
    LDS     SI, [BP + 0Ah]

    LODSW
    MOV     CX, AX
    SUB     BX, AX ;subtract the bitmap x from screen x

    LODSW
    XCHG    CX, AX
    XCHG    DS, ES
    XCHG    SI, DI
StartY2:
    PUSH    CX
    MOV     CX, AX
    REP MOVSB
    ADD     SI, BX
    POP     CX
    LOOP StartY2


    POP     DS
    POP     BP
    RET 8
GET13 ENDP

PUBLIC ARRAYPOINT13
ARRAYPOINT13 PROC FAR
	PUSH BP
	MOV BP, SP
	push ds
	LDS  SI, [BP + 10]
	LODSW
	mul WORD PTR [bp + 6]
	add ax, [bp + 8]
	INC AX
	INC AX
	add  SI, ax
	XOR  AH, AH
	MOV  AL, [SI]

	pop ds
	pop bp
	RETF 8
ARRAYPOINT13 ENDP

PUBLIC MAPADD
MAPADD PROC FAR
   PUSH BP
   MOV BP, SP
   PUSH DS
   
   LDS SI, [BP + 6]
   LES DI, [BP + 14]
   INC WORD PTR [SI]
   MOV AX, ES:[DI]
   CMP [SI], AX
   JE MapAddCarry
   POP DS
   POP BP

   RETF 12
MapAddCarry:
   MOV WORD PTR [SI], 0
   LDS SI, [BP + 10]
   INC WORD PTR [SI]
   POP DS
   POP BP

   RETF 12
ENDP

PUBLIC MAPSUB
MAPSUB PROC FAR
   PUSH BP
   MOV BP, SP
   
   LES DI, [BP + 6]
   CMP WORD PTR ES:[DI], 0
   JZ MapSubCarry
   DEC WORD PTR ES:[DI]
   POP BP

   RETF 12
MapSubCarry:
   PUSH DS

   LDS SI, [BP + 14]
   MOV AX, [SI]
   DEC AX
   MOV ES:[DI], AX
   LES DI, [BP + 10]
   DEC WORD PTR ES:[DI]

   POP DS
   POP BP

   RETF 12
ENDP

PUBLIC LONGTIMER
LONGTIMER PROC FAR
   MOV AX, 2C00h
   INT 21h
MOV AX, 0
MOV AL, CH
MOV CH, 60
MUL CH
MOV CH, 0
ADD AX, CX
MOV CX, DX
MOV DX,6000
MUL DX
;At this point the values in AX,DX can not be discarded
MOV BX, AX
MOV AL, CH
MOV AH,100
MUL AH
MOV CH, 0
ADD AX, CX
XCHG BX, AX
ADD AX, BX
ADC DX, 0
   RETF
LONGTIMER ENDP
