DEFINT A-Z
'$DYNAMIC

DECLARE SUB GetKey (KeyHold AS STRING)
DECLARE FUNCTION FileOPEN% (FileName$, Mode$)
DECLARE SUB Keytest ()
DECLARE SUB ExportKeys (FileName$, KeyMappings() AS STRING, KeyedEvents%())


DIM SHARED KeyHold AS STRING '* 2

Restart:
PRINT "Do you wish to..."
PRINT "1. See the values of Different Keys"
PRINT "2. Define Key Maps"
PRINT "3. END"
LINE INPUT A$
GetResponse1:
IF VAL(A$) = 1 THEN
   CALL Keytest
   GOTO Restart
END IF
IF VAL(A$) = 3 THEN END

IF VAL(A$) <> 2 THEN GOTO GetResponse1


PRINT "How may Unique Events do you want to be triggered by a keypress?";
LINE INPUT A$
IF VAL(A$) = 0 THEN
   PRINT "  You must have at least 1 Event"
END IF
EventTotal% = VAL(A$)
REDIM KeyedEvents(1 TO EventTotal%)
   KeyListTotal% = 0
FOR i% = 1 TO EventTotal
  PRINT "How many different keys do you want to associate with event"; i%; "?";
  LINE INPUT A$
  KeyedEvents(i%) = KeyListTotal%
  KeyListTotal% = KeyListTotal% + VAL(A$)
NEXT
REDIM KeyMappings(0 TO KeyListTotal% - 1) AS STRING' * 2
Currevent% = 1
J = 0
FOR i = 0 TO KeyListTotal% - 1
    IF Currevent <> UBOUND(KeyedEvents%) THEN
      IF KeyedEvents%(Currevent% + 1) = i THEN Currevent% = Currevent + 1: J = 0
    END IF
    J = J + 1
    PRINT "Hit key"; J; "for event"; Currevent; "now."
    DO
      GetKey KeyHold
    LOOP UNTIL KeyHold <> CHR$(0) + CHR$(0)
    KeyMappings(i%) = KeyHold
NEXT i
PRINT "Do you wish to save this configuration?"
DO
  GetKey KeyHold
  SELECT CASE KeyHold
  CASE "Y" + CHR$(0), "y" + CHR$(0)
    PRINT "Input Filename";
    LINE INPUT A$
    ExportKeys A$, KeyMappings(), KeyedEvents%()
  CASE "N" + CHR$(0), "n" + CHR$(0)
  EXIT DO
  CASE ELSE
  END SELECT
LOOP
GOTO Restart
END

REM $STATIC
FUNCTION FileOPEN% (FileName$, Mode$)
    FileOPEN% = FREEFILE
    OPEN Mode$, FREEFILE, FileName$
END FUNCTION

SUB Keytest
  PRINT "Press Esc to Quit..."

DO
  GetKey KeyHold
  IF KeyHold <> CHR$(0) + CHR$(0) THEN
    FOR i = 1 TO 2
      PRINT ASC(MID$(KeyHold, i, 1));
    NEXT
    IF KeyHold = CHR$(27) + CHR$(0) THEN PRINT : EXIT SUB
  END IF
LOOP

END SUB

